#!/usr/bin/python
#
# this is a very dirty code to browse a zope site and
# launch vim to edit the desired file 
# still requires a lot of work 
# it requires a vim compiled with python support
# if you use debian, just apt-get install vim-python for it


###########################
# PLEASE EDIT THIS SETTINGS
host		='localhost'
port		= 8021
username	= 'admin'
password	= 'secret'
vim			= 'vim'
favsFile	= 'favs.conf'
###########################

from ftplib import FTP
import os,DIALOG,string,sys

d = DIALOG
ftp = FTP(host)
ftp.connect(host,port)
ftp.login(username,password)

dir_output = {}
def my_callback(line):
	'''this function is the callback for ftp.dir()
	it will store all results on global variable: dir_output'''

	global dir_output
	if line[0:1] == 'd':
		type = 'directory'
	else:
		type = 'file'

	filename = string.split(line)[8]
	dir_output[filename] = type
	return 1

def sortme(a,b):
	''' this is just the user-defined sort function
	used to sort the dir_output '''
	if cmp(a[1],b[1]) == 0:
		return cmp(a[0],b[0])
	else:
		return cmp(a[1],b[1])


def showDialog(path):
	''' this function is an ugly infinite loop
	that will show a dialog for browsing the current path'''
	global this_func,dir_output,vim
	dir_output = {}
	ftp.dir(path,my_callback)
	menuentries = []
	for item in dir_output.items():
		menuentries.append( (item[0],item[1]) )
	
	menuentries.sort(sortme)
	ftp.cwd(path)
	pwd = ftp.pwd()
	selection = d.menu("zope editor",pwd,22,50,15,menuentries)
	# if user hits "CANCEL" we'll quit gracefully
	if selection == 0:
		ftp.quit()
		return 0
	
	fullpath = "%s/%s" %(pwd,selection)

	if dir_output[selection] == 'directory':
		showDialog(fullpath)
	else:
		os.system('%s -c "map *o :pyfile ftpopen.py<CR>%s<CR><CR>:set filetype=html<CR>" -c "map *w :pyfile ftpsave.py<CR>" -s autoload.vim' %(vim,fullpath))
		showDialog(pwd)


def showDialogFavs(file):
	''' this function works like showDialog() but
	it will use the favs.conf file instead of ftp'''
	import re
	menuentries = []
	menudict    = {}
	fav = open(file,'r')
	while (1):
		line = fav.readline()
		# break on EOF and skip on comment or empty line
		if not line:
			break
		elif line[0:1] == '#':
			continue
		elif line[0:1] == '\n' or line[0:1] == '\r\n':
			continue
		else:
			parts		= re.split("\t+",line)
			tag			= string.strip(parts[0])
			fullpath	= string.strip(parts[1])
			format		= string.strip(parts[2])

			menuentries.append(tag,format)
			menudict[tag] = {'tag': tag, 'fullpath': fullpath, 'format': format}
	fav.close()

	selection = d.menu("zope editor","favs",22,50,15,menuentries)
	# if user hits "CANCEL" we'll quit gracefully
	if selection == 0:
		return 0
	os.system('%s -c "map *o :pyfile ftpopen.py<CR>%s<CR><CR>:set filetype=%s<CR>" -c "map *w :pyfile ftpsave.py<CR>" -s autoload.vim' %(vim,menudict[selection]['fullpath'],menudict[selection]['format']))
	showDialogFavs(file)

	
			
# OK HERE WE GO
usage = 'usage: %s[-h] [-c [path_to_favs.conf]]' %sys.argv[0]

if len(sys.argv) > 1:
	if sys.argv[1] == '-h':
		print usage
	if sys.argv[1] == '-c':
		if len(sys.argv) == 3:
			showDialogFavs(sys.argv[2])
		elif len(sys.argv) == 2:
			showDialogFavs(favsFile)
		else:
			print usage
	else:
		print usage
else:
	showDialog('/')
